<id>
Show Only Attachments
</id>

<version>
1.02
</version>

<mod info>
it will add a button beside Rply, Notify etc... that will allow the user to view only posts with attachments, or to view all posts
</mod info>

<author>
Gandalf
</author>

<homepage>
www.siemens-mobiles.org
</homepage>

<edit file>
$themedir/Display.template.php
</edit file>

<search for>
	$buttonArray = array();
</search for>

<add after>
	if($_REQUEST['only_attach'])
			$buttonArray[] = '<a href="' . $scripturl . '?topic=' . $context['current_topic'] . '.' . $context['start'] . '">' . ($settings['use_image_buttons'] ? '<img src="' . $settings['images_url'] . '/' . $context['user']['language'] . '/viewallposts.gif" alt="' . $txt['show_all_posts'] . '" border="0" />' : $txt['show_all_posts']) . '</a>';
	else 
			$buttonArray[] = '<a href="' . $scripturl . '?'. ($_REQUEST['only_attach']? 'only_attach=true;' : '') . 'topic=' . $context['current_topic'] . '.' . $context['start'] . ';only_attach=true">' . ($settings['use_image_buttons'] ? '<img src="' . $settings['images_url'] . '/' . $context['user']['language'] . '/viewattachments.gif" alt="' . $txt['show_only_attachments'] . '" border="0" />' : $txt['show_only_attachments']) . '</a>';
</add after>

<edit file>
$sourcedir/Display.php
</edit file>

<search for>
	$context['page_index'] = constructPageIndex($scripturl . '?topic=' . $topic, $_REQUEST['start'], $topicinfo['numReplies'] + 1, $modSettings['defaultMaxMessages'], true);
</search for>

<replace>
		$context['page_index'] = constructPageIndex($scripturl . '?'. ($_REQUEST['only_attach']? 'only_attach=true;' : '') . 'topic=' . $topic, $_REQUEST['start'], $topicinfo['numReplies'] + 1, $modSettings['defaultMaxMessages'], true);
</replace>

<search for>
			$context['page_index'] .= '&nbsp;<a href="' . $scripturl . '?topic=' . $topic . '.0;all">' . $txt[190] . '</a> ';
</search for>

<replace>
			$context['page_index'] .= '&nbsp;<a href="' . $scripturl . '?topic=' . $topic . '.0;all"' . ($_REQUEST['only_attach']? ';only_attach=true' : '') . '>' . $txt[190] . '</a> ';
</replace>

<search for>
	// Add 1 to the number of views of this topic.
	if (empty($_SESSION['last_read_topic']) || $_SESSION['last_read_topic'] != $topic)
	{
		db_query("
			UPDATE {$db_prefix}topics
			SET numViews = numViews + 1
			WHERE ID_TOPIC = $topic
			LIMIT 1", __FILE__, __LINE__);

		$_SESSION['last_read_topic'] = $topic;
	}
</search for>

<add after>

	if ($_REQUEST['only_attach'])
	{
		//initialising the array
		$ID_MSG = array();
		
		//get all the attachments that are in this topic
		$request = db_query("
		SELECT ID_MSG
		FROM {$db_prefix}attachments
		ORDER BY ID_MSG", __FILE__, __LINE__);
		while ($row = mysql_fetch_assoc($request))
			$ID_MSG[] = $row['ID_MSG'];
		if (empty($ID_MSG))
			$ID_MSG = array(0);
		mysql_free_result($request);
		array_unique($ID_MSG);
	
		//get the number of replies (with attachments)
		$request = db_query("
		SELECT COUNT(ID_MSG)
		FROM {$db_prefix}messages
		WHERE ID_TOPIC = $topic AND ID_MSG IN (" . implode(',',$ID_MSG) . ")", __FILE__, __LINE__);
		list ($numreplieswithattachments) = mysql_fetch_row($request);
		mysql_free_result($request);
	}
</add after>

<search for>
	// Get all the important topic info.
	$request = db_query("
		SELECT
			t.numReplies, t.numViews, t.locked, ms.subject, t.isSticky, t.ID_POLL, t.ID_MEMBER_STARTED,
			IFNULL(lt.logTime, 0) AS logTime, t.ID_FIRST_MSG
		FROM {$db_prefix}topics AS t, {$db_prefix}messages AS ms
			LEFT JOIN {$db_prefix}log_topics AS lt ON (lt.ID_TOPIC = $topic AND lt.ID_MEMBER = $ID_MEMBER)
		WHERE t.ID_TOPIC = $topic
			AND ms.ID_MSG = t.ID_FIRST_MSG
		LIMIT 1", __FILE__, __LINE__);
	if (mysql_num_rows($request) == 0)
		fatal_lang_error(472, false);
	$topicinfo = mysql_fetch_assoc($request);
	mysql_free_result($request);
</search for>

<add after>

	//if only attachments then changing the number of replies
	if($_REQUEST['only_attach'])
		$topicinfo['numReplies']=$numreplieswithattachments;
</add after>

<search for>
	// Get each post and poster in this topic.
	$request = db_query("
		SELECT ID_MSG, ID_MEMBER
		FROM {$db_prefix}messages
		WHERE ID_TOPIC = $topic
		ORDER BY ID_MSG " . ($ascending ? '' : 'DESC') . ($modSettings['defaultMaxMessages'] == -1 ? '' : "
		LIMIT $start, $limit"), __FILE__, __LINE__);
</search for>

<replace>
	// Get each post and poster in this topic.
	$request = db_query("
		SELECT ID_MSG, ID_MEMBER
		FROM {$db_prefix}messages
		WHERE ID_TOPIC = $topic " . ($_REQUEST['only_attach']? 'AND ID_MSG IN (' . implode(',', $ID_MSG) . ')' : '') . "
		ORDER BY ID_MSG " . ($ascending ? '' : 'DESC') . ($modSettings['defaultMaxMessages'] == -1 ? '' : "
		LIMIT $start, $limit"), __FILE__, __LINE__);
</replace>

<search for>
	// If there _are_ messages here... (probably an error otherwise :!)
	if (!empty($messages))
	{
		// Fetch attachments.
		if (!empty($modSettings['attachmentEnable']))
		{
			$request = db_query("
				SELECT ID_ATTACH, ID_MSG, filename, IFNULL(size, 0) AS filesize, downloads
				FROM {$db_prefix}attachments
				WHERE ID_MSG IN (" . implode(',', $messages) . ")", __FILE__, __LINE__);
			$temp = array();
			while ($row = mysql_fetch_assoc($request))
			{
				$temp[$row['ID_ATTACH']] = $row;

				if (!isset($attachments[$row['ID_MSG']]))
					$attachments[$row['ID_MSG']] = array();
			}
			mysql_free_result($request);

			// This is better than sorting it with the query...
			ksort($temp);

			foreach ($temp as $row)
				$attachments[$row['ID_MSG']][] = $row;
		}
</search for>

<add after>
		
		//if the user requested only to view messages with attachments
		if ($_REQUEST['only_attach'])
		{
			//we must do a filtrage of the $messages array
			//by erasing ID_MSG that does not exist in the $attachments
			$temp_messages = array();
			$temp_posters = array();
			for($i=0;$i < count($messages);$i++)
			{
				if( array_key_exists($messages[$i], $attachments) )
				{
					//the key is found then we add the message
					$temp_messages[] = $messages[$i];
				}
				else //this post does not have attachments
					continue;
			}
			if( count ($temp_messages) > 0)
			{
				$topicinfo['has_attachments']=true;	
				$messages = $temp_messages;
			}
		}
</add after>

<edit file>
$languagedir/Modifications.english.php
</edit file>

<search for>
?>
</search for>

<add before>
$txt['show_all_posts'] = 'View all posts';
$txt['show_only_attachments'] = 'View only posts with attachments';
</add before>